using System;
using Unit4.CollectionsLib;
using Unit4.UtilsLib;
using System.Text;

namespace ConsoleApplicationMergeLists
{
    class Program
    {
        static void Main(string[] args)
        {
            //Console.WriteLine("     ");
            Console.WriteLine("Build two Lists width random items");
		    List<int> list1 = ListUtils.CreateRandomList(5, -100, 100);
		    List<int> list2 = ListUtils.CreateRandomList(10, -100, 100);
		    Console.WriteLine(list1);
		    Console.WriteLine(list2);
		    Console.WriteLine("-----------------------------------------------");
    		
    		
		    //Console.WriteLine(" ");
            Console.WriteLine("Sort Two Lists");
		    MergeSort(list1);
		    MergeSort(list2);
		    Console.WriteLine(list1);
		    Console.WriteLine(list2);
		    Console.WriteLine("-----------------------------------------------");
    		
    		
		    //Console.WriteLine(" ");
            Console.WriteLine("Merge Two Lists");
		    Console.WriteLine(MergeLists(list1, list2));
		    Console.WriteLine("-----------------------------------------------");
            Console.ReadLine();
        }
        //       
        public static List<int> MergeLists(List<int> list1, List<int> list2)
        {
            Node<int> pos1 = list1.GetFirst();
            Node<int> pos2 = list2.GetFirst();
            Node<int> pos3 = null;

            List<int> list3 = new List<int>();

            while (pos1 != null && pos2 != null)
            {
                int small;
                if (pos1.GetInfo() < pos2.GetInfo())
                {
                    small = pos1.GetInfo();
                    pos1 = pos1.GetNext();
                }
                else
                {
                    small = pos2.GetInfo();
                    pos2 = pos2.GetNext();
                }
                pos3 = list3.Insert(pos3, small);
            }

            while (pos1 != null)
            {
                pos3 = list3.Insert(pos3, pos1.GetInfo());
                pos1 = pos1.GetNext();
            }

            while (pos2 != null)
            {
                pos3 = list3.Insert(pos3, pos2.GetInfo());
                pos2 = pos2.GetNext();
            }

            return (list3);
        }


        //    
        public static List<int>[] SplitList(List<int> list)
        {
            List<int>[] split = new List<int>[2];

            split[0] = new List<int>();
            split[1] = new List<int>();

            Node<int> pos1 = list.GetFirst();
            Node<int> pos2 = list.GetFirst();
            Node<int> pos3 = null;

            while (pos2 != null && pos2.GetNext() != null)
            {
                pos3 = split[0].Insert(pos3, pos1.GetInfo());
                pos1 = pos1.GetNext();
                pos2 = pos2.GetNext().GetNext();
            }

            pos3 = null;
            while (pos1 != null)
            {
                pos3 = split[1].Insert(pos3, pos1.GetInfo());
                pos1 = pos1.GetNext();
            }

            return (split);
        }

        //   
        public static List<int> MergeSort(List<int> list)
        {
            List<int> sortedList;

            if (list.GetFirst().GetNext() == null) //     
            {
                sortedList = new List<int>();
                sortedList.Insert(null, list.GetFirst().GetInfo());
            }
            else
            {
                List<int>[] split = SplitList(list);
                List<int> left = MergeSort(split[0]);
                List<int> right = MergeSort(split[1]);
                sortedList = MergeLists(left, right);
            }

            return (sortedList);
        }
    }
}
